summaryrefslogtreecommitdiff
path: root/plugins/python
diff options
context:
space:
mode:
authorTuowen Zhao <ztuowen@gmail.com>2022-01-01 02:26:11 -0600
committerTuowen Zhao <ztuowen@gmail.com>2022-01-01 02:26:11 -0600
commit49edbf438ed690c76e6b2af80368c59404cf0167 (patch)
tree129b3adb2f5f39a1329a426a3b7d51ed2c2290c1 /plugins/python
parent1bc186dabe12b3d01b2257e82f3a104c48b8b3c7 (diff)
parent78c91ccbf99c77bd4d9cdb74279a40776721f66d (diff)
downloadzsh-49edbf438ed690c76e6b2af80368c59404cf0167.tar.gz
zsh-49edbf438ed690c76e6b2af80368c59404cf0167.tar.bz2
zsh-49edbf438ed690c76e6b2af80368c59404cf0167.zip
Merge remote-tracking branch 'origin/master'
Diffstat (limited to 'plugins/python')
-rw-r--r--plugins/python/README.md34
-rw-r--r--plugins/python/python.plugin.zsh89
2 files changed, 83 insertions, 40 deletions
diff --git a/plugins/python/README.md b/plugins/python/README.md
index b95ffe679..c1f0adef8 100644
--- a/plugins/python/README.md
+++ b/plugins/python/README.md
@@ -1,19 +1,29 @@
-# python plugin
+# Python plugin
-The plugin adds several aliases for useful [python](https://www.python.org/) commands.
+The plugin adds several aliases for useful [Python](https://www.python.org/) commands.
-To use it, add `python` to the plugins array of your zshrc file:
-```
+To use it, add `python` to the plugins array in your zshrc file:
+
+```zsh
plugins=(... python)
```
## Aliases
-| Command | Description |
-|------------------|---------------------------------------------------------------------------------|
-| `py` | Runs `python` |
-| `ipython` | Runs the appropriate `ipython` version according to the activated virtualenv |
-| `pyfind` | Finds .py files recursively in the current directory |
-| `pyclean [dirs]` | Deletes byte-code and cache files from a list of directories or the current one |
-| `pygrep <text>` | Looks for `text` in .py files |
-| `pyuserpaths` | Add --user site-packages to PYTHONPATH, for all installed python versions. |
+| Command | Description |
+| ---------------- | -------------------------------------------------------------------------------------- |
+| `py` | Runs `python` |
+| `ipython` | Runs the appropriate `ipython` version according to the activated virtualenv |
+| `pyfind` | Finds .py files recursively in the current directory |
+| `pyclean [dirs]` | Deletes byte-code and cache files from a list of directories or the current one |
+| `pygrep <text>` | Looks for `text` in `*.py` files in the current directory, recursively |
+| `pyuserpaths` | Add user site-packages folders to `PYTHONPATH`, for Python 2 and 3 |
+| `pyserver` | Starts an HTTP server on the current directory (use `--directory` for a different one) |
+
+## Virtual environments
+
+The plugin provides two utilities to manage Python venvs:
+
+- `mkv [name]`: make a new virtual environment called `name` (default: `venv`) in current directory.
+
+- `vrun [name]`: activate virtual environment called `name` (default: `venv`) in current directory.
diff --git a/plugins/python/python.plugin.zsh b/plugins/python/python.plugin.zsh
index 276eb6f91..7a73ab92a 100644
--- a/plugins/python/python.plugin.zsh
+++ b/plugins/python/python.plugin.zsh
@@ -7,40 +7,37 @@ alias pyfind='find . -name "*.py"'
# Remove python compiled byte-code and mypy/pytest cache in either the current
# directory or in a list of specified directories (including sub directories).
function pyclean() {
- ZSH_PYCLEAN_PLACES=${*:-'.'}
- find ${ZSH_PYCLEAN_PLACES} -type f -name "*.py[co]" -delete
- find ${ZSH_PYCLEAN_PLACES} -type d -name "__pycache__" -delete
- find ${ZSH_PYCLEAN_PLACES} -depth -type d -name ".mypy_cache" -exec rm -r "{}" +
- find ${ZSH_PYCLEAN_PLACES} -depth -type d -name ".pytest_cache" -exec rm -r "{}" +
+ find "${@:-.}" -type f -name "*.py[co]" -delete
+ find "${@:-.}" -type d -name "__pycache__" -delete
+ find "${@:-.}" -depth -type d -name ".mypy_cache" -exec rm -r "{}" +
+ find "${@:-.}" -depth -type d -name ".pytest_cache" -exec rm -r "{}" +
}
# Add the user installed site-packages paths to PYTHONPATH, only if the
# directory exists. Also preserve the current PYTHONPATH value.
# Feel free to autorun this when .zshrc loads.
function pyuserpaths() {
- local targets=("python2" "python3") # bins
-
- # Get existing interpreters.
- local interps=()
- for target in $targets; do
- [ `command -v $target` ] && interps+=($target)
- done
-
- # Check for a non-standard install directory.
- local user_base="${HOME}/.local"
- [ $PYTHONUSERBASE ] && user_base=$PYTHONUSERBASE
-
- # Add version specific paths, if:
- # it exists in the filesystem;
- # it isn't in PYTHONPATH already.
- for interp in $interps; do
- # Get minor release version.
- local ver=`$interp -V 2>&1`
- ver=`echo ${ver:7} | cut -d '.' -f 1,2` # The patch version is variable length, truncate it.
-
- local site_pkgs="${user_base}/lib/python${ver}/site-packages"
- [[ -d $site_pkgs && ! $PYTHONPATH =~ $site_pkgs ]] && export PYTHONPATH=${site_pkgs}:$PYTHONPATH
- done
+ setopt localoptions extendedglob
+
+ # Check for a non-standard install directory.
+ local user_base="${PYTHONUSERBASE:-"${HOME}/.local"}"
+
+ local python version site_pkgs
+ for python in python2 python3; do
+ # Check if command exists
+ (( ${+commands[$python]} )) || continue
+
+ # Get minor release version.
+ # The patch version is variable length, truncate it.
+ version=${(M)${"$($python -V 2>&1)":7}#[^.]##.[^.]##}
+
+ # Add version specific path, if:
+ # - it exists in the filesystem
+ # - it isn't in $PYTHONPATH already.
+ site_pkgs="${user_base}/lib/python${version}/site-packages"
+ [[ -d "$site_pkgs" && ! "$PYTHONPATH" =~ (^|:)"$site_pkgs"(:|$) ]] || continue
+ export PYTHONPATH="${site_pkgs}${PYTHONPATH+":${PYTHONPATH}"}"
+ done
}
# Grep among .py files
@@ -48,3 +45,39 @@ alias pygrep='grep -nr --include="*.py"'
# Run proper IPython regarding current virtualenv (if any)
alias ipython="python -c 'import IPython; IPython.terminal.ipapp.launch_new_instance()'"
+
+# Share local directory as a HTTP server
+alias pyserver="python -m http.server"
+
+
+## venv utilities
+
+# Activate a the python virtual environment specified.
+# If none specified, use 'venv'.
+function vrun() {
+ local name="${1:-venv}"
+ local venvpath="${name:P}"
+
+ if [[ ! -d "$venvpath" ]]; then
+ echo >&2 "Error: no such venv in current directory: $name"
+ return 1
+ fi
+
+ if [[ ! -f "${venvpath}/bin/activate" ]]; then
+ echo >&2 "Error: '${name}' is not a proper virtual environment"
+ return 1
+ fi
+
+ . "${venvpath}/bin/activate" || return $?
+ echo "Activated virtual environment ${name}"
+}
+
+# Create a new virtual environment, with default name 'venv'.
+function mkv() {
+ local name="${1:-venv}"
+ local venvpath="${name:P}"
+
+ python3 -m venv "${name}" || return
+ echo >&2 "Created venv in '${venvpath}'"
+ vrun "${name}"
+}